# YGOPro 猜卡器

应对~~iDuel群里的~~猜卡游戏而设计的猜卡器。

支持直接按搜索条件猜卡，也支持~~内鬼用的~~按模糊逻辑，即固定数量的条件可能是错误的情况下，猜卡。

~~Urara terminator~~

## 需要的资源文件

* `cards.cdb` 从 YGOPro 目录复制即可。

* `ocgcore` 从 https://github.com/Fluorohydride/ygopro-core 获取，并改名为 `ocgcore` 放在本目录下。

## 如何使用

* `npm ci && npm run build`

* 复制 `info.example.yaml` 到 `info.yaml` 下，并填写相关的搜索条件。

为了方便填写，卡片种类以及种族属性等字段，可以填写别名，即 `{TYPE_MONSTER}` `{RACE_MACHINE}` 等，与 YGOPro 的脚本引擎常量一致。

* `npm start` 列出所有可行集，并给出卡片密码的中位数，可以按照中位数询问游戏举办方进行二分查找。

## info.yaml 的格式

```yaml
upper: 100000000
lower: 0
noFilterAlias: false
conditions:
  - type: lflist
    statement: true
    data:
      match: '^2021.4$'
      limit: 3
  - type: regex
    statement: true
    data:
      field: name
      pattern: '^.*雷龙$'
where:
  - "type & {TYPE_MONSTER} > 0"
mayIncorrectStatements:
  - incorrectCountMin: 4
	incorrectCountMax: 4
    lessThanOrEqual: true
    where:
      - "type & {TYPE_FUSION} = 0"
      - "type & {TYPE_SYNCHRO} > 0"
      - "type & {TYPE_XYZ} > 0"
      - "type & {TYPE_LINK} > 0"
```

参数如下。

* `upper` 卡号上界，用于二分定卡号。**模糊逻辑规则下请保持该字段默认，并把卡号条件填写在模糊逻辑的字段内。**

* `lower` 卡号下界，用于二分定卡号。

* `noFilterAlias` 不过滤异画卡。

* `where` 约束条件，使用 SQL 语句填写，相互之间是 AND 的关系。

* `conditions` 额外过滤条件。

### 额外过滤条件

一个额外过滤条件的示例如下。

```yaml
conditions:
  - type: lflist
    statement: true
    data:
      match: '^2021.4$'
      limit: 3
  - type: regex
    statement: true
    data:
      field: name
      pattern: '^.*雷龙$'
```

* `type` 过滤器名称

* `statement` 条件是否成立，默认 `true`

* `data` 具体信息，根据过滤器而不同

#### regex 正则表达式过滤器

* `field` 支持 `name` 和 `desc`，卡名还是字段

* `pattern` 正则表达式内容

#### lflist 卡表过滤器

* `match` 正则表达式给出的对应卡表名称。

* `limit` 卡表情况。0 1 2 3。-1 代表在卡表里面存在。

### 模糊逻辑

`mayIncorrectStatements` 为模糊逻辑字段，非模糊逻辑规则可以删除该字段以不使用模糊逻辑查找。

模糊逻辑为数组，可以指定多组模糊逻辑查询，相互之间是 AND 的关系。

每一组模糊逻辑条件包含字段意义如下。

* `incorrectCountMin` 错误条件最小个数。

* `incorrectCountMax` 错误条件最大个数。

* `where` 约束条件，使用 SQL 语句填写。其中有一定数量的错误条件。
